/*
   sd_user.h for SmartDongle API version 3.2


   www.smartdongle.com

   MicroWorks, Inc.
   2808 North Cole Road
   Boise, ID 83704
*/

#ifndef _DEFINE_965A16E6_0C8E_40f2_B8C4_79CB5A250254
#define _DEFINE_965A16E6_0C8E_40f2_B8C4_79CB5A250254

#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

/* {5C98F9F9-C082-431a-A0AD-B32F70BD2689} */
DEFINE_GUID(QTS_USK_GUID, \
0x5c98f9f9, 0xc082, 0x431a, 0xa0, 0xad, 0xb3, 0x2f, 0x70, 0xbd, 0x26, 0x89);

#define QTSDONGLE_IOCTL_INDEX  0x0800


#define IOCTL_QTSDONGLE_GET_DEVICE_DESCRIPTOR   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+1,\
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_CONFIG_DESCRIPTOR   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+2, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_RESET_PIPE              CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+6, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_DRIVER_REVISION     CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+7, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_STRING_DESCRIPTOR   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+8, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_SEND_KEY                CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0A, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_KEY                 CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0B, \
                                                METHOD_BUFFERED,  \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_WRITE_PORT              CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0C, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_READ_EEPROM             CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0E, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_WRITE_EEPROM            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x0F, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_SECURITY_STATE      CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x11, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_RESET_SECURITY_STATE    CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x12, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_KEY_STATE           CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x13, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_RESET_KEY_STATE         CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x14, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_SEND_HOST_VERIFY_REQUEST \
                                                CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x15, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_REQUEST_PAGE            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x16, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_PAGE_FLAGS          CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x17, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_TWC_FLAG            CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x18, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_BUSY_FLAG           CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x19, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_EEPROM_ERROR_FLAG   CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1A, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_SOFT_RESET              CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1C, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_SEND_PORT               CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1D, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_FLAGS               CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1E, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_SET_MODE                CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x1F, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_GET_MODE                CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x20, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#define IOCTL_QTSDONGLE_SET_STRICT              CTL_CODE(FILE_DEVICE_UNKNOWN, \
                                                QTSDONGLE_IOCTL_INDEX+0x22, \
                                                METHOD_BUFFERED, \
                                                FILE_ANY_ACCESS)

#if defined(__cplusplus) || defined(__cplusplus__)
}
#endif

#endif /* _DEFINE_965A16E6_0C8E_40f2_B8C4_79CB5A250254 */